package de.hdm_stuttgart.mi.sd1.test.aufgabe1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.sd1.aufgabe1._1_Helper;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
@SuppressWarnings({"UnusedDeclaration"})
public class Test_1_Helper extends ExaminationTestDefaults {

  /**
   * Abschnitt 1: 3 Strings null?
   */
  @Test @Marking(points = 5) public void test_100_stringsAllNull() {
    Assert.assertTrue(_1_Helper.keinStringIstNull("", "", ""));
    Assert.assertTrue(_1_Helper.keinStringIstNull("A", "BB", "CC"));

    Assert.assertFalse(_1_Helper.keinStringIstNull(null, "XY", "Z"));
    Assert.assertFalse(_1_Helper.keinStringIstNull("XYZ", null, "Z"));
    Assert.assertFalse(_1_Helper.keinStringIstNull(null, null, "Z"));
    Assert.assertFalse(_1_Helper.keinStringIstNull("XYZ", "XY", null));
    Assert.assertFalse(_1_Helper.keinStringIstNull(null, "XY", null));
    Assert.assertFalse(_1_Helper.keinStringIstNull("XYZ", null, null));
    Assert.assertFalse(_1_Helper.keinStringIstNull(null, null, null));
  }

  /**
   * Abschnitt 2: 3 Strings mit Mindestlänge 1?
   */
  @Test  @Marking(points = 4) public void test_200_stringsMindestLaenge() {
    Assert.assertFalse(_1_Helper.alleMindestlaengeEins("", "", ""));
    Assert.assertFalse(_1_Helper.alleMindestlaengeEins(null, "As", "Ass"));
    Assert.assertFalse(_1_Helper.alleMindestlaengeEins("Nicht Null", null, "Null"));
    Assert.assertFalse(_1_Helper.alleMindestlaengeEins("a", "b", null));
    Assert.assertFalse(_1_Helper.alleMindestlaengeEins("", "Ces", "Def"));
    Assert.assertFalse(_1_Helper.alleMindestlaengeEins("Ces", "", "Def"));
    Assert.assertFalse(_1_Helper.alleMindestlaengeEins("Def", "Ces", ""));

    Assert.assertTrue(_1_Helper.alleMindestlaengeEins("A", "B", "C"));
    Assert.assertTrue(_1_Helper.alleMindestlaengeEins("A", "Brett", "Caesar"));
  }


  /**
   * Abschnitt 3: Irgendwie teilbar?
   */
  @Test @Marking(points = 4)
  public void test_300_teilbar() {
    Assert.assertTrue(_1_Helper.istIrgendwieTeilbar(18, 3));
    Assert.assertTrue(_1_Helper.istIrgendwieTeilbar(3, 18));
    Assert.assertTrue(_1_Helper.istIrgendwieTeilbar(18, -3));
    Assert.assertTrue(_1_Helper.istIrgendwieTeilbar(-3, 18));
    Assert.assertTrue(_1_Helper.istIrgendwieTeilbar(-18, 3));
    Assert.assertTrue(_1_Helper.istIrgendwieTeilbar(3, -18));
    Assert.assertTrue(_1_Helper.istIrgendwieTeilbar(-64, -16));
    Assert.assertTrue(_1_Helper.istIrgendwieTeilbar(-16, -64));
  }
  /**
   * Sonderfall einfache 0 ist immer teilbar.
   */
  @Test @Marking(points = 4) public void test_320_nullIstTeilbar() {
    Assert.assertTrue(_1_Helper.istIrgendwieTeilbar(1, 0));
    Assert.assertTrue(_1_Helper.istIrgendwieTeilbar(0, 1));
    Assert.assertTrue(_1_Helper.istIrgendwieTeilbar(0, 987));
    Assert.assertTrue(_1_Helper.istIrgendwieTeilbar(-987, 0));
  }
  /**
   * Sonderfall doppelte 0 ist nicht teilbar.
   */
  @Test public void test_340_nichtTeilbar() {
    Assert.assertFalse(_1_Helper.istIrgendwieTeilbar(0, 0));
    Assert.assertTrue(_1_Helper.istIrgendwieTeilbar(0, 1));
  }


  /**
   * Abschnitt 4: Zeige Leerzeichen
   */

  @Test @Marking(points = 2) public void test_400_empty() {
    Assert.assertEquals("", _1_Helper.markiereLeerzeichen(""));
  }
  @Test @Marking(points = 2) public void test_420_single() {
    Assert.assertEquals("a", _1_Helper.markiereLeerzeichen("a"));
  }
  @Test @Marking(points = 2) public void test_430_einmalLeer() {
    Assert.assertEquals("_a", _1_Helper.markiereLeerzeichen(" a"));
    Assert.assertEquals("a_", _1_Helper.markiereLeerzeichen("a "));
  }
  @Test @Marking(points = 2) public void test_440_einmalLeer() {
    Assert.assertEquals("abc_def", _1_Helper.markiereLeerzeichen("abc def"));
    Assert.assertEquals("_abcdef", _1_Helper.markiereLeerzeichen(" abcdef"));
    Assert.assertEquals("abcdef_", _1_Helper.markiereLeerzeichen("abcdef "));
  }

  @Test @Marking(points = 2) public void test_460_einmalLeer() {
    Assert.assertEquals("__abc_def___", _1_Helper.markiereLeerzeichen("  abc def   "));
    Assert.assertEquals("_abc___def", _1_Helper.markiereLeerzeichen(" abc   def"));
  }
}