package de.hdm_stuttgart.mi.sd1.test.aufgabe1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.sd1.aufgabe1._3_ArrayHelper;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class Test_3_ArrayHelper extends ExaminationTestDefaults {

  /**
   * Abschnitt 1: Summe Stringlängen
   */
  @Test
  public void test_100_null() {
    Assert.assertEquals("Für null anstelle eines Arrays wird die Länge 0 erwartet",
        0, _3_ArrayHelper.getGesamtLaenge(null));
  }
  @Test
  public void test_110_arrayContentNull() {
    Assert.assertEquals(0, _3_ArrayHelper.getGesamtLaenge(new String[]{null}));
    Assert.assertEquals(0, _3_ArrayHelper.getGesamtLaenge(new String[]{null, null}));
  }
  @Test
  public void test_112_arrayContentEmpty() {
    Assert.assertEquals(0, _3_ArrayHelper.getGesamtLaenge(new String[]{}));
  }

  @Test
  public void test_110_standard() {
    Assert.assertEquals(8, _3_ArrayHelper.getGesamtLaenge(new String[]{"1", "234", "5678"}));
  }

  @Test
  public void test_120_MixedNull() {
    Assert.assertEquals(9, _3_ArrayHelper.getGesamtLaenge(new String[]{null, "1", null, "234", null, "56789"}));
  }

  /**
   * Abschnitt 2: Summe Höhenanstiege
   */

  @Test public void test_200_ein() {
    Assert.assertEquals(0, _3_ArrayHelper.getHoehenAnstieg(new int[]{111}));
  }
  @Test public void test_220_zwei() {
    Assert.assertEquals(1, _3_ArrayHelper.getHoehenAnstieg(new int[]{111, 112}));
    Assert.assertEquals(487, _3_ArrayHelper.getHoehenAnstieg(new int[]{-428, 59})); // Totes Meer / Masada
  }
  @Test public void test_240_standard() {
    Assert.assertEquals(380, _3_ArrayHelper.getHoehenAnstieg(new int[]{320, 400, 530, 200, 370}));
  }
  @Test public void test_260_Null() {
    Assert.assertEquals(0, _3_ArrayHelper.getHoehenAnstieg(new int[]{111, 111}));
    Assert.assertEquals(0, _3_ArrayHelper.getHoehenAnstieg(new int[]{10, 0}));
    Assert.assertEquals(0, _3_ArrayHelper.getHoehenAnstieg(new int[]{500, 400, 400, 300, 200, 0, -30}));
  }

  /**
   * Abschnitt 3: Wertefolge in Array
   */

  @Test
  public void test_300_common() {
    Assert.assertTrue(_3_ArrayHelper.contains(new int[]{5}, new int[]{1, 5, 6, 2}));
    Assert.assertTrue(_3_ArrayHelper.contains(new int[]{6}, new int[]{1, 5, 6, 2}));
    Assert.assertFalse(_3_ArrayHelper.contains(new int[]{7}, new int[]{1, 5, 6, 2}));

    Assert.assertTrue(_3_ArrayHelper.contains(new int[]{5, 6}, new int[]{1, 5, 6, 2}));
    Assert.assertFalse(_3_ArrayHelper.contains(new int[]{6, 5}, new int[]{1, 5, 6, 2}));
  }
  @Test
  public void test_320_limits() {
    Assert.assertTrue(_3_ArrayHelper.contains(new int[]{1}, new int[]{1, 5, 6, 2}));
    Assert.assertTrue(_3_ArrayHelper.contains(new int[]{1, 5}, new int[]{1, 5, 6, 2}));
    Assert.assertTrue(_3_ArrayHelper.contains(new int[]{1, 5, 6}, new int[]{1, 5, 6, 2}));

    Assert.assertTrue(_3_ArrayHelper.contains(new int[]{5, 6, 2}, new int[]{1, 5, 6, 2}));
    Assert.assertTrue(_3_ArrayHelper.contains(new int[]{6, 2}, new int[]{1, 5, 6, 2}));
    Assert.assertTrue(_3_ArrayHelper.contains(new int[]{2}, new int[]{1, 5, 6, 2}));

    Assert.assertTrue(_3_ArrayHelper.contains(new int[]{55}, new int[]{55}));
    Assert.assertTrue(_3_ArrayHelper.contains(new int[]{5, 6, -1, 2}, new int[]{5, 6, -1, 2}));

    Assert.assertFalse(_3_ArrayHelper.contains(new int[]{6}, new int[]{1}));
  }
  @Test
  public void test_340_emptyOrOversize() {
    Assert.assertTrue(_3_ArrayHelper.contains(new int[]{}, new int[]{}));
    Assert.assertTrue(_3_ArrayHelper.contains(new int[]{}, new int[]{1, 5, 6, 2}));

    Assert.assertFalse(_3_ArrayHelper.contains(new int[]{1, 5, 6, 2}, new int[]{}));
    Assert.assertFalse(_3_ArrayHelper.contains(new int[]{1, 5, 6, 2}, new int[]{5, 6}));
  }
}