package de.hdm_stuttgart.mi.sd1.test.aufgabe2;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.sd1.aufgabe2.Geo;
import de.hdm_stuttgart.mi.sd1.test.ignore_me.P;
import de.hdm_stuttgart.mi.sd1.test.ignore_me.Wrapper;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

import java.util.Arrays;

/**
 * Testing {@link Geo}.
 */

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class Test_Geo extends ExaminationTestDefaults {

  @Test @Marking(points = 4)
  public void test_100_constructGradMinuteSekunde() {

    final Wrapper<Geo> stuttgartBreite = new Wrapper<>(Geo.class, P.n(48), P.n(46), P.n(56));

    Assert.assertEquals(48, stuttgartBreite.getInt("grad"));
    Assert.assertEquals(46, stuttgartBreite.getInt("minuten"));
    Assert.assertEquals(56, stuttgartBreite.getInt("sekunden"));
  }

  @Test @Marking(points = 4)
  public void test_200_getDezimal() {

    final Wrapper<Geo> stuttgartBreite = new Wrapper<>(Geo.class, P.n(48), P.n(46), P.n(56));

    Assert.assertEquals(48.78222222222224, stuttgartBreite.invokeDouble("getDezimal"), 1.E-10);
  }

  @Test
  public void test_300_constructDezimal() {

    final Wrapper<Geo> stuttgartBreite = new Wrapper<>(Geo.class, P.n(48.78222222222224));

    Assert.assertEquals(48, stuttgartBreite.getInt("grad"));
    Assert.assertEquals(46, stuttgartBreite.getInt("minuten"));
    Assert.assertEquals(56, stuttgartBreite.getInt("sekunden"));

    Assert.assertEquals(48.78222222222224, stuttgartBreite.invokeDouble("getDezimal"), 1E-10);
  }


  @Test @Marking(points = 4)
  public void test_400_displayDefault() {

    final Wrapper<Geo> atlantaBreite = new Wrapper<>(Geo.class, P.n(33), P.n(44), P.n(56));
    Assert.assertEquals("(33°,44´,56´´)", atlantaBreite.invokeObject("toString"));

    final Wrapper<Geo> stuttgartBreite = new Wrapper<>(Geo.class, P.n(48), P.n(46), P.n(56));
    Assert.assertEquals("(48°,46´,56´´)", stuttgartBreite.invokeObject("toString"));
  }

  @Test
  public void test_420_displayDezimal() {

    final Wrapper<Geo> beirutBreite = new Wrapper<>(Geo.class, P.n(33), P.n(53), P.n(19));
    Assert.assertEquals("(33°,53´,19´´)", beirutBreite.invokeObject("toString"));
    beirutBreite.invokeObject("nutzeDezimalDarstellung", P.n(true));
    Assert.assertEquals("33.888611", beirutBreite.invokeObject("toString"));
  }

  @Test @Marking(points = 2)
  public void test_500_equal() {
    final Geo
        g1 = new Wrapper<>(Geo.class, P.n(10), P.n(20), P.n(30)).getInstance(),
        g2 = new Wrapper<>(Geo.class, P.n(30), P.n(20), P.n(10)).getInstance(),
        g3 = new Wrapper<>(Geo.class, P.n(10), P.n(20), P.n(30)).getInstance();

    Assert.assertNotEquals(g1, g2);
    Assert.assertEquals(g1, g3);
    Assert.assertNotEquals(g2, g3);

    Assert.assertNotEquals(g2, g1);
    Assert.assertEquals(g3, g1);
    Assert.assertNotEquals(g3, g2);
  }

  @Test
  public void test_520_hash() {
    final Geo
        g1 = new Wrapper<>(Geo.class, P.n(10), P.n(20), P.n(30)).getInstance(),
        g3 = new Wrapper<>(Geo.class, P.n(10), P.n(20), P.n(30)).getInstance();

    Assert.assertEquals(g1.hashCode(), g3.hashCode());
  }

  @Test
  public void test_600_sort() {

    final Geo
        ort1 = new Wrapper<>(Geo.class, P.n(75), P.n(0), P.n(1)).getInstance(),
        ort2 = new Wrapper<>(Geo.class, P.n(48), P.n(44), P.n(56)).getInstance(),
        ort3 = new Wrapper<>(Geo.class, P.n(48), P.n(44), P.n(30)).getInstance(),
        ort4 = new Wrapper<>(Geo.class, P.n(48), P.n(44), P.n(35)).getInstance();

    final Geo[] orte = new Geo[]{
        ort1,
        ort2,
        ort3,
        ort4
    };

    Arrays.sort(orte);

    Assert.assertSame(ort3, orte[0]);
    Assert.assertSame(ort4, orte[1]);
    Assert.assertSame(ort2, orte[2]);
    Assert.assertSame(ort1, orte[3]);
  }

  @Test @Marking(points = 2)
  public void test_700_immutable() {

    final Class<Geo> geoClass = Geo.class;

    Wrapper.assertFinal(geoClass, "grad");
    Wrapper.assertFinal(geoClass, "minuten");
    Wrapper.assertFinal(geoClass, "sekunden");
  }
}